#! /usr/bin/env python

import re
import sys

r = re.compile('register_cvar\\("(\\w+)" *, *"([\\w\\.]+)"( *, *([\\w\\|]+))?( *, *"([\\w\\.]+)")?(\\);? *//(.+))?')

if len(sys.argv) > 3:
	print "Usage: python cfgcreator.py sourcefile"
	exit()

try:
	fin = open(sys.argv[1], 'r')
except IOError:
	print "Couldn't open file '" + sys.argv[1] + "'"
	exit()

s = fin.read()
fin.close()

s = re.sub('\\\\(.)', lambda m: str(m.group(1)), s)

matches = r.findall(s)

if len(matches) == 0:
	print "Specified plugin doesn't register any cvar"
	exit()

filename = sys.argv[1].replace('.sma', '.cfg')

try:
	fout = open(filename, 'w')
except IOError:
	print "Couldn't open output file '" + filename
	exit()
	
fout.write('// This file was auto-generated by CfgCreator\n// CVars for plugin "' + sys.argv[1] + '"\n\n')

for match in matches:
	fout.write('// ' + match[0])
	fout.write('\n// Description: ' + match[7].strip() if sys.argv.count('-no-desc') == 0 and len(match[7]) > 0 else '')
	fout.write('\n// Flags: ' + match[3].replace(' ', '').replace('|', ', ').replace('FCVAR_', '') if match[3] != '' and match[3] != '0' and match[3] != '_' else '')
	fout.write('\n// Default: ' + match[1])
	fout.write('\n' + match[0] + ' "' + match[1] + '"')
	fout.write('\n\n')

fout.close()

print 'Done'